"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OAuthClientCredentialsClient = void 0;
var _common_1 = require("../../index");
var fetch_ponyfill_1 = __importDefault(require("fetch-ponyfill"));
var form_data_1 = __importDefault(require("form-data"));
var OAuthClientCredentialsClient = (function () {
    function OAuthClientCredentialsClient(_clientId, _clientSecret, _host) {
        if (_host === void 0) { _host = _common_1.bugsplatAppHostUrl; }
        this._clientId = _clientId;
        this._clientSecret = _clientSecret;
        this._host = _host;
        this._accessToken = '';
        this._tokenType = '';
        this._createFormData = function () { return new form_data_1.default(); };
        this._fetch = (0, fetch_ponyfill_1.default)().fetch;
    }
    OAuthClientCredentialsClient.createAuthenticatedClient = function (clientId, clientSecret, host) {
        if (host === void 0) { host = _common_1.bugsplatAppHostUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        client = new OAuthClientCredentialsClient(clientId, clientSecret, host);
                        return [4, client.login()];
                    case 1:
                        _a.sent();
                        return [2, client];
                }
            });
        });
    };
    OAuthClientCredentialsClient.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            var url, method, body, request, response, responseJson, status, json;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this._host + "/oauth2/authorize";
                        method = 'POST';
                        body = this.createFormData();
                        body.append('grant_type', 'client_credentials');
                        body.append('client_id', this._clientId);
                        body.append('client_secret', this._clientSecret);
                        body.append('scope', 'restricted');
                        request = {
                            method: method,
                            body: body
                        };
                        return [4, this.fetch(url, request)];
                    case 1:
                        response = _a.sent();
                        return [4, response.json()];
                    case 2:
                        responseJson = _a.sent();
                        status = response.status;
                        if (responseJson.error === 'invalid_client') {
                            throw new Error('Could not authenticate, check credentials and try again');
                        }
                        this._accessToken = responseJson.access_token;
                        this._tokenType = responseJson.token_type;
                        json = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2, responseJson];
                        }); }); };
                        return [2, {
                                status: status,
                                json: json
                            }];
                }
            });
        });
    };
    OAuthClientCredentialsClient.prototype.createFormData = function () {
        return this._createFormData();
    };
    OAuthClientCredentialsClient.prototype.fetch = function (route, init) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                url = new URL(route, this._host);
                init = init !== null && init !== void 0 ? init : {};
                if (!init.headers) {
                    init.headers = {};
                }
                init.headers['Authorization'] = this._tokenType + " " + this._accessToken;
                return [2, this._fetch(url.href, init)];
            });
        });
    };
    return OAuthClientCredentialsClient;
}());
exports.OAuthClientCredentialsClient = OAuthClientCredentialsClient;
//# sourceMappingURL=oauth-client-credentials-api-client.js.map