"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadCollection = void 0;
var argument_contracts_1 = __importDefault(require("argument-contracts"));
var _crash_1 = require("../index");
var ThreadCollection = (function () {
    function ThreadCollection(options) {
        argument_contracts_1.default.assertArrayOf(options.stackFrames, _crash_1.StackFrame, 'options.stackFrames');
        if (options.threadId) {
            argument_contracts_1.default.assertString(options.threadId);
            this.threadId = options.threadId;
        }
        else {
            this.threadId = '';
        }
        if (options.stackId) {
            argument_contracts_1.default.assertNumber(options.stackId);
            this.stackId = options.stackId;
        }
        else {
            this.stackId = 0;
        }
        if (options.subKeyDepth) {
            argument_contracts_1.default.assertNumber(options.subKeyDepth);
            this.subKeyDepth = options.subKeyDepth;
        }
        else {
            this.subKeyDepth = 0;
        }
        this.stackFrames = options.stackFrames && options.stackFrames.length
            ? options.stackFrames.map(function (stackFrame) { return new _crash_1.StackFrame(stackFrame); })
            : [];
    }
    ThreadCollection.prototype.getEntryPoint = function () {
        return this.subKeyDepth
            ? this.stackFrames[this.subKeyDepth - 1]
            : this.stackFrames[0];
    };
    return ThreadCollection;
}());
exports.ThreadCollection = ThreadCollection;
//# sourceMappingURL=thread-collection.js.map