import { ApiDataFilterGroup } from '../../../index';
import FormData from 'form-data';
import { ColumnSortOrder } from './column-sort-order';
export declare class TableDataFormDataBuilder {
    private _formDataFactory;
    private _formParts;
    constructor(_formDataFactory: () => FormData, _formParts?: Record<string, string>);
    withColumnGroups(groups: Array<string> | undefined): TableDataFormDataBuilder;
    withFilterGroups(groups: Array<ApiDataFilterGroup> | undefined): TableDataFormDataBuilder;
    withPage(page?: number): TableDataFormDataBuilder;
    withPageSize(pageSize?: number): TableDataFormDataBuilder;
    withSortColumn(sortColumn: string | undefined): TableDataFormDataBuilder;
    withSortOrder(sortOrder: ColumnSortOrder | undefined): TableDataFormDataBuilder;
    withDatabase(database: string | undefined): TableDataFormDataBuilder;
    withApplications(applications: Array<string>): TableDataFormDataBuilder;
    withVersions(versions: Array<string>): TableDataFormDataBuilder;
    entries(): Record<string, string>;
    build(): FormData;
}
